#!/bin/bash
set -e
#===============================================================
#
#===============================================================
. ./func_write_conf_regrid_head.sh
. ./func_write_conf_regrid_gs_io.sh
. ./func_write_conf_regrid_gs_mat-latlon.sh
. ./func_write_conf_regrid_gs_mat-raster.sh
. ./func_write_conf_regrid_gs_cmf-latlon.sh
. ./func_write_conf_regrid_regridding.sh
. ./func_write_conf_regrid_options.sh
#===============================================================
#
#===============================================================
landType="river"

srcMeshName="cmf"
tgtMeshName="${io_row_name}"
srcVrfFormat="index"
tgtVrfFormat="auto"

f_conf="../set/01_make_rt/${srcMeshName}_to_${tgtMeshName}.conf"
rm -f ${f_conf} && touch ${f_conf}

write_conf_regrid_head\
  ${f_conf} ${srcMeshName} ${tgtMeshName}
write_conf_regrid_gs_cmf_latlon\
  ${f_conf} ${landType}
write_conf_regrid_gs_io\
  ${f_conf} ${io_row_name}\
  ${io_row_nx} ${io_row_ny}\
  ${io_row_west} ${io_row_east} ${io_row_south} ${io_row_north}\
  ${io_row_is_south_to_north}
write_conf_regrid_regridding\
  ${f_conf} ${srcMeshName} ${tgtMeshName}\
  ${srcVrfFormat} ${tgtVrfFormat}
write_conf_regrid_options\
  ${f_conf}

${exec_main_std_regrid} ${f_conf}
