#!/bin/bash
set -e
#===============================================================
#
#===============================================================
. ./func_write_conf_regrid_head.sh
. ./func_write_conf_regrid_gs_io.sh
. ./func_write_conf_regrid_gs_mat-latlon.sh
. ./func_write_conf_regrid_gs_mat-raster.sh
. ./func_write_conf_regrid_regridding.sh
. ./func_write_conf_regrid_options.sh
#===============================================================
#
#===============================================================
layer=0
for landType in ${list_landType}; do
  layer=$(( layer + 1 ))

  srcMeshName="${io_bnd_name}"
  tgtMeshName="mat-${landType}"
  srcVrfFormat="auto"
  tgtVrfFormat="index"

  f_conf="../set/01_make_rt/${srcMeshName}_to_${tgtMeshName}.conf"
  rm -f ${f_conf} && touch ${f_conf}

  write_conf_regrid_head\
    ${f_conf} ${srcMeshName} ${tgtMeshName}
  write_conf_regrid_gs_io\
    ${f_conf} ${io_bnd_name}\
    ${io_bnd_nx} ${io_bnd_ny}\
    ${io_bnd_west} ${io_bnd_east} ${io_bnd_south} ${io_bnd_north}\
    ${io_bnd_is_south_to_north}\
    ${layer}
  write_conf_regrid_gs_mat_latlon\
    ${f_conf} ${landType}
  write_conf_regrid_regridding\
    ${f_conf} ${srcMeshName} ${tgtMeshName}\
    ${srcVrfFormat} ${tgtVrfFormat}
  write_conf_regrid_options\
    ${f_conf}

  ${exec_main_std_regrid} ${f_conf}
done
