#!/bin/bash
set -e
#===============================================================
#
#===============================================================
. ./func_write_conf_regrid_head.sh
. ./func_write_conf_regrid_gs_io.sh
. ./func_write_conf_regrid_gs_mat-latlon.sh
. ./func_write_conf_regrid_gs_mat-raster.sh
. ./func_write_conf_regrid_gs_cmf-latlon.sh
. ./func_write_conf_regrid_regridding.sh
. ./func_write_conf_regrid_options.sh
#===============================================================
#
#===============================================================
for landType in ${list_landType}; do

  srcMeshName="${io_metnc_name}"
  tgtMeshName="mat-${landType}"
  srcVrfFormat="auto"
  tgtVrfFormat="index"

  f_conf="../set/01_make_rt/${srcMeshName}_to_${tgtMeshName}.conf"
  rm -f ${f_conf} && touch ${f_conf}

  write_conf_regrid_head\
    ${f_conf} ${srcMeshName} ${tgtMeshName}
  write_conf_regrid_gs_io\
    ${f_conf} ${io_metnc_name}\
    ${io_metnc_nx} ${io_metnc_ny}\
    ${io_metnc_west} ${io_metnc_east} ${io_metnc_south} ${io_metnc_north}\
    ${io_metnc_is_south_to_north}
  write_conf_regrid_gs_mat_raster\
    ${f_conf} ${landType}
  write_conf_regrid_regridding\
    ${f_conf} ${srcMeshName} ${tgtMeshName}\
    ${srcVrfFormat} ${tgtVrfFormat}
  write_conf_regrid_options\
    ${f_conf}

  ${exec_main_std_regrid} ${f_conf}
done
