#!/bin/bash
set -e
#===============================================================
#
#===============================================================
. ./func_write_conf_regrid_head.sh
. ./func_write_conf_regrid_gs_io.sh
. ./func_write_conf_regrid_gs_mat-latlon.sh
. ./func_write_conf_regrid_gs_mat-raster.sh
. ./func_write_conf_regrid_gs_cmf-latlon.sh
. ./func_write_conf_regrid_regridding.sh
. ./func_write_conf_regrid_options.sh
#===============================================================
#
#===============================================================
landType="river"

srcMeshName="mat-${landType}"
tgtMeshName="cmf"
srcVrfFormat="index"
tgtVrfFormat="index"

f_conf="../set/01_make_rt/${srcMeshName}_to_${tgtMeshName}.conf"
rm -f ${f_conf} && touch ${f_conf}

write_conf_regrid_head\
  ${f_conf} ${srcMeshName} ${tgtMeshName}
write_conf_regrid_gs_mat_latlon\
  ${f_conf} ${landType}
write_conf_regrid_gs_cmf_latlon\
  ${f_conf} ${landType}
write_conf_regrid_regridding\
  ${f_conf} ${srcMeshName} ${tgtMeshName}\
  ${srcVrfFormat} ${tgtVrfFormat}
write_conf_regrid_options\
  ${f_conf}

${exec_main_std_regrid} ${f_conf}
