module lib_io_system
  use lib_base
  use lib_log
  implicit none
  private
  !-------------------------------------------------------------
  public :: get_terminal_nCols
  !-------------------------------------------------------------
contains
!===============================================================
!
!===============================================================
subroutine get_terminal_nCols(n, stat)
  implicit none
  integer, intent(out) :: n
  integer, intent(out) :: stat

  character(32), pointer :: s
  integer, pointer :: cl
  integer, pointer :: cstat
  integer :: ios

  call echo(code%bgn, 'get_terminal_nCols', '-p -x2')
  !-------------------------------------------------------------
  stat = 0

  allocate(s)
  allocate(cl)
  allocate(cstat)

  call c_system_tput_cols(s, cl, cstat)

  if( cstat == 0 )then
    read(s(:cl),*,iostat=ios) n
    if( ios /= 0 )then
      n = 0
      stat = 1
    endif
  else
    n = 0
    stat = 1
  endif

  deallocate(s)
  deallocate(cl)
  deallocate(cstat)
  !-------------------------------------------------------------
  call echo(code%ret)
end subroutine get_terminal_nCols
!===============================================================
!
!===============================================================
end module lib_io_system
